Subject: Re: [bug#73028] [PATCH] doc: Document usage of #:out-of-source? for meson-build-system.

From: Maxim Cournoyer <[email-masked]>
Date: Sat, 14 Sep 2024 22:41:16 +0900

Hi Dariqq,

Dariqq <[email-masked]> writes:

> On 12.09.24 14:02, Maxim Cournoyer wrote:
>> Hi Dariqq,
>> Dariqq <[email-masked]> writes:
>> [...]
>> 
>>>>> Maybe it should not be an option at all and instead be #t
>>>>> unconditionally in 'install-license-files phase in meson-build-system?
>>>> Given most build phases of the gnu-build-system, which support
>>>> #:out-of-source? are reused in the meson-build-system, this argument
>>>> needs to be set to #t (which it currently is).  But perhaps there's a
>>>> way to hide it from the users, perhaps via the 'private-keywords'
>>>> variable defined in the 'lower' procedure of the (guix build-system
>>>> meson) module (I haven't tested).
>>>>
>>>
>>> Something like that might be a better solution. I am not sure how
>>> these 'private-keywords' work: It looks like #:meson is one but you
>>> can definitly override the default meson being used. Also the
>>> private-arguments seem to get stripped from the arguments in the bag
>>> (not sure what that is exactly) so they might not be passed to the
>>> build phases
>> I think your understanding is correct. The private options are
>> accepted
>> on the build system, but not propagated to the lower build strata
>> (applied to phases).  So what we'd like here is to *not* expose an
>> #:out-of-source argument at the build system level, and enforce
>> #:out-of-source #t for the lower build code.  I guess the static #t
>> argument could be added to the bag arguments.
>> 
>
> This does not work. I tried adding that to the arguments in the bag
> (and reverting the previous patch) but get an error:
>
> Unrecognized keyword: #:out-of-source?
>
> I guess this is because meson-(cross-)build now get a keyword they
> don't know.

Hm.  Thanks for trying it out.

> Maybe we could replace the install-license-files function with a
> version that has #:out-of-source? set to #t?. Not sure if there is an
> elegant way to do this?

Is this really the only reused phase from gnu-build-system that makes
use of #:out-of-source?  I'd expect the 'configure' to be one, also.
And in general it'd be a bit more risky; new gnu-build-system phases
that would make use of #:out-of-source could start breaking in the
future until thye are specially handled.

-- 
Thanks,
Maxim